diff --git a/copy.c b/copy.c
index 1f2283f553..955352b06e 100644
--- a/copy.c
+++ b/copy.c
@@ -69,7 +69,6 @@ int mutt_copy_hdr(FILE *in, FILE *out, LOFF_T off_start, LOFF_T off_end,
   bool ignore = false;
   char buf[LONG_STRING]; /* should be long enough to get most fields in one pass */
   char *nl = NULL;
-  struct List *t = NULL;
   char **headers = NULL;
   int hdr_count;
   int x;
@@ -158,9 +157,10 @@ int mutt_copy_hdr(FILE *in, FILE *out, LOFF_T off_start, LOFF_T off_end,
    */
   if (flags & CH_REORDER)
   {
-    for (t = HeaderOrderList; t; t = t->next)
+    struct STailQNode *np;
+    STAILQ_FOREACH(np, &HeaderOrderList, entries)
     {
-      mutt_debug(3, "Reorder list: %s\n", t->data);
+      mutt_debug(3, "Reorder list: %s\n", np->data);
       hdr_count++;
     }
   }
@@ -252,11 +252,14 @@ int mutt_copy_hdr(FILE *in, FILE *out, LOFF_T off_start, LOFF_T off_end,
       /* Find x -- the array entry where this header is to be saved */
       if (flags & CH_REORDER)
       {
-        for (t = HeaderOrderList, x = 0; (t); t = t->next, x++)
+        struct STailQNode *np;
+        x = 0;
+        STAILQ_FOREACH(np, &HeaderOrderList, entries)
         {
-          if (ascii_strncasecmp(buf, t->data, mutt_strlen(t->data)) == 0)
+          ++x;
+          if (ascii_strncasecmp(buf, np->data, mutt_strlen(np->data)) == 0)
           {
-            mutt_debug(2, "Reorder: %s matches %s\n", t->data, buf);
+            mutt_debug(2, "Reorder: %s matches %s\n", np->data, buf);
             break;
           }
         }
diff --git a/globals.h b/globals.h
index 664012d93b..10cff989e1 100644
--- a/globals.h
+++ b/globals.h
@@ -212,11 +212,11 @@ WHERE struct STailQHead AttachAllow INITVAL(STAILQ_HEAD_INITIALIZER(AttachAllow)
 WHERE struct STailQHead AttachExclude INITVAL(STAILQ_HEAD_INITIALIZER(AttachExclude));
 WHERE struct STailQHead InlineAllow INITVAL(STAILQ_HEAD_INITIALIZER(InlineAllow));
 WHERE struct STailQHead InlineExclude INITVAL(STAILQ_HEAD_INITIALIZER(InlineExclude));
-WHERE struct List *HeaderOrderList INITVAL(0);
-WHERE struct List *Ignore INITVAL(0);
+WHERE struct STailQHead HeaderOrderList INITVAL(STAILQ_HEAD_INITIALIZER(HeaderOrderList));
+WHERE struct STailQHead Ignore INITVAL(STAILQ_HEAD_INITIALIZER(Ignore));
 WHERE struct List *MailtoAllow INITVAL(0);
 WHERE struct List *MimeLookupList INITVAL(0);
-WHERE struct List *UnIgnore INITVAL(0);
+WHERE struct STailQHead UnIgnore INITVAL(STAILQ_HEAD_INITIALIZER(UnIgnore));
 
 WHERE struct RxList *Alternates INITVAL(0);
 WHERE struct RxList *UnAlternates INITVAL(0);
diff --git a/init.c b/init.c
index 22320bb1c9..5efa0a1a79 100644
--- a/init.c
+++ b/init.c
@@ -934,6 +934,26 @@ static int parse_ifdef(struct Buffer *tmp, struct Buffer *s, unsigned long data,
   return 0;
 }
 
+static void remove_from_stailq(struct STailQHead *head, const char *str)
+{
+  if (mutt_strcmp("*", str) == 0)
+    mutt_stailq_free(head); /* ``unCMD *'' means delete all current entries */
+  else
+  {
+    struct STailQNode *np, *tmp;
+    STAILQ_FOREACH_SAFE(np, head, entries, tmp)
+    {
+      if (ascii_strcasecmp(str, np->data) == 0)
+      {
+        STAILQ_REMOVE(head, np, STailQNode, entries);
+        FREE(&np->data);
+        FREE(&np);
+        break;
+      }
+    }
+  }
+}
+
 static int parse_unignore(struct Buffer *buf, struct Buffer *s,
                           unsigned long data, struct Buffer *err)
 {
@@ -943,9 +963,9 @@ static int parse_unignore(struct Buffer *buf, struct Buffer *s,
 
     /* don't add "*" to the unignore list */
     if (strcmp(buf->data, "*") != 0)
-      add_to_list(&UnIgnore, buf->data);
+      add_to_stailq(&UnIgnore, buf->data);
 
-    remove_from_list(&Ignore, buf->data);
+    remove_from_stailq(&Ignore, buf->data);
   } while (MoreArgs(s));
 
   return 0;
@@ -957,8 +977,8 @@ static int parse_ignore(struct Buffer *buf, struct Buffer *s,
   do
   {
     mutt_extract_token(buf, s, 0);
-    remove_from_list(&UnIgnore, buf->data);
-    add_to_list(&Ignore, buf->data);
+    remove_from_stailq(&UnIgnore, buf->data);
+    add_to_stailq(&Ignore, buf->data);
   } while (MoreArgs(s));
 
   return 0;
@@ -989,26 +1009,6 @@ static int parse_stailq(struct Buffer *buf, struct Buffer *s, unsigned long data
   return 0;
 }
 
-static void remove_from_stailq(struct STailQHead *head, const char *str)
-{
-  if (mutt_strcmp("*", str) == 0)
-    mutt_stailq_free(head); /* ``unCMD *'' means delete all current entries */
-  else
-  {
-    struct STailQNode *np, *tmp;
-    STAILQ_FOREACH_SAFE(np, head, entries, tmp)
-    {
-      if (ascii_strcasecmp(str, np->data) == 0)
-      {
-        STAILQ_REMOVE(head, np, STailQNode, entries);
-        FREE(&np->data);
-        FREE(&np);
-        break;
-      }
-    }
-  }
-}
-
 static int parse_unstailq(struct Buffer *buf, struct Buffer *s,
                         unsigned long data, struct Buffer *err)
 {
diff --git a/init.h b/init.h
index 2261c1f8fd..4aedbbc4eb 100644
--- a/init.h
+++ b/init.h
@@ -4592,7 +4592,7 @@ const struct Command Commands[] = {
 #endif
   { "group",            parse_group,            MUTT_GROUP },
   { "ungroup",          parse_group,            MUTT_UNGROUP },
-  { "hdr_order",        parse_list,             UL &HeaderOrderList },
+  { "hdr_order",        parse_stailq,           UL &HeaderOrderList },
   { "ifdef",            parse_ifdef,            0 },
   { "ifndef",           parse_ifdef,            1 },
   { "finish",           finish_source,          0 },
@@ -4648,7 +4648,7 @@ const struct Command Commands[] = {
   { "unalias",          parse_unalias,          0 },
   { "unalternative_order",parse_unstailq,       UL &AlternativeOrderList },
   { "unauto_view",      parse_unstailq,         UL &AutoViewList },
-  { "unhdr_order",      parse_unlist,           UL &HeaderOrderList },
+  { "unhdr_order",      parse_unstailq,         UL &HeaderOrderList },
   { "unhook",           mutt_parse_unhook,      0 },
   { "unignore",         parse_unignore,         0 },
   { "unlists",          parse_unlists,          0 },
diff --git a/list.h b/list.h
index 8ec46931e4..304debc772 100644
--- a/list.h
+++ b/list.h
@@ -23,6 +23,8 @@
 #ifndef _MUTT_LIST_H
 #define _MUTT_LIST_H
 
+#include <stdbool.h>
+#include "ascii.h"
 #include "lib.h"
 
 /**
@@ -94,4 +96,15 @@ static inline void mutt_stailq_free(struct STailQHead *h)
   STAILQ_INIT(h);
 }
 
+static inline bool mutt_stailq_match(const char *s, struct STailQHead *h)
+{
+  struct STailQNode *np;
+  STAILQ_FOREACH(np, h, entries)
+  {
+    if (*np->data == '*' || ascii_strncasecmp(s, np->data, strlen(np->data)) == 0)
+      return true;
+  }
+  return false;
+}
+
 #endif /* _MUTT_LIST_H */
diff --git a/muttlib.c b/muttlib.c
index ca947e47fd..9dad84fd27 100644
--- a/muttlib.c
+++ b/muttlib.c
@@ -399,7 +399,7 @@ bool mutt_matches_list(const char *s, struct List *t)
  */
 int mutt_matches_ignore(const char *s)
 {
-  return mutt_matches_list(s, Ignore) && !mutt_matches_list(s, UnIgnore);
+  return mutt_stailq_match(s, &Ignore) && !mutt_stailq_match(s, &UnIgnore);
 }
 
 char *mutt_expand_path(char *s, size_t slen)
